// WDTest.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//

// fr die Windows Socket 2 wird wsock32.lib bentigt
///#pragma comment(lib, "ws2_32.lib")

#include "stdafx.h"


typedef struct {
  unsigned char ucASCIIParity[4]; // Anzahl Parittsfehler seit letzter Abfrage
                                  // 3 Ziffern mit abschlieender '\0'
  unsigned char ucASCIISpikes[4]; // Anzahl erkannter Spikes seit letzter Abfrage
                                  // 3 Ziffern mit abschlieender '\0',
  unsigned char ucBINParity;      // Binrwert der Anzahl Parittsfehler
  unsigned char ucBINSpikes;      // Binrwert der Anzahl Spikes
} S7LANINFO;

int main(int argc, char* argv[])
{
  SOCKET              sS7LAN;
  DWORD               dwTimeout = 1000L; // 1 Sekunde Timeout
  int                 NaggleOn = 1;
  struct sockaddr_in  sS7LANAdr;
  struct linger       sLinger;
  S7LANINFO           sInfo;
	WSADATA             sWSAData;

  printf("S7LAN Watchdog Test V1.00\n\n");
  memset(&sInfo,0,sizeof(sInfo));
  
	if (WSAStartup(MAKEWORD(1,1),&sWSAData) != 0)
	{
    printf("WSA Startup fehlerhjaft => Abbruch\n");
    return(0);
	}

  sS7LAN = socket(AF_INET, SOCK_STREAM, 0); //0
  if (sS7LAN != INVALID_SOCKET){

    // Sende/Empfangstimeout einstellen
    setsockopt( sS7LAN,  SOL_SOCKET,  SO_SNDTIMEO,(char *)&dwTimeout, sizeof(dwTimeout));
    setsockopt( sS7LAN,  SOL_SOCKET,  SO_RCVTIMEO,(char *)&dwTimeout, sizeof(dwTimeout));
    
    // Naggle-Algorithmus aus
    setsockopt(sS7LAN, IPPROTO_TCP, TCP_NODELAY,(char*) &NaggleOn, sizeof(NaggleOn));

    sS7LANAdr.sin_family = AF_INET;  
    sS7LANAdr.sin_port   = htons(133);          // Port 133; Statistic Service
    sS7LANAdr.sin_addr.S_un.S_un_b.s_b1 = 192;  // IP-Adresse des S7LAN's
    sS7LANAdr.sin_addr.S_un.S_un_b.s_b2 = 168;
    sS7LANAdr.sin_addr.S_un.S_un_b.s_b3 = 1;
    sS7LANAdr.sin_addr.S_un.S_un_b.s_b4 = 56;

    if (connect(sS7LAN, (struct sockaddr *)&sS7LANAdr, sizeof(sS7LANAdr)) != SOCKET_ERROR) {

      // etwas senden => daraufhin ende S7LAN antwort
      send(sS7LAN, (const char *) "A", 1, 0);

      // Daten vom S7LAN empfangen
      if (recv(sS7LAN, (char *)&sInfo, sizeof(sInfo), 0)) {
        printf("Parity: %s Spikes: %s\nParity: %3d Spikes: %3d\n",&sInfo.ucASCIIParity[0],&sInfo.ucASCIISpikes[0],(unsigned int) sInfo.ucBINParity,(unsigned int) sInfo.ucBINSpikes );
      } else {
        printf("Empfang vom S7LAN gestrt\n");
      }

      sLinger.l_linger = 0;
      sLinger.l_onoff  = 1; // unmittelbar schlieen

      shutdown(sS7LAN,2); // Read and Write

      setsockopt(sS7LAN,  SOL_SOCKET, SO_LINGER, (char *)&sLinger, sizeof(sLinger));

      closesocket(sS7LAN);
    } else {
      printf("S7LAN nicht ereichbar\n");
    }
  } else {
    printf("Socket nicht ffenbar\n");
  }

	return 0;
}

